
#include <container_double_vector.h>


container_double_vector::container_double_vector(){}
container_double_vector::container_double_vector(const container_double_vector& cont)
{double_list=cont.double_list;}
container_double_vector::~container_double_vector(){destroy();}

int container_double_vector::destroy()
{double_list.resize(0);return 0;}

const container_double_vector& container_double_vector::operator=(const container_double_vector& cont)
{
  destroy();
  for(int k=0;k<cont.size();k++)
    double_list.push_back(cont[k]);
  return *this;
}
bool operator==(const container_double_vector& cont_1,const container_double_vector& cont_2)
{
  if(cont_1.size()!=cont_2.size())
    return 0;
  for(int k=0;k<cont_1.size();k++)
    if(cont_1[k]!=cont_2[k])
      return 0;
  return 1;
}
bool operator!=(const container_double_vector& cont_1,const container_double_vector& cont_2)
{
  if(cont_1==cont_2)
    return 0;
  return 1;
}
  
int container_double_vector::size() const
{return double_list.size();}


const double_vector& container_double_vector::operator[](int k_double_vector) const
{
  if(k_double_vector<0 || k_double_vector>=size())
    {printf("Error in (const) container_double_vector[%d], size=%d\n",k_double_vector,size());exit(-1);}
  return double_list[k_double_vector];
}
double_vector& container_double_vector::operator[](int k_double_vector)
{
  if(k_double_vector<0 || k_double_vector>=size())
    {printf("Error in container_double_vector[%d], size=%d\n",k_double_vector,size());exit(-1);}
  return double_list[k_double_vector];
}

int container_double_vector::add(const double_vector& to_add)
{double_list.push_back(to_add);return 0;}



